//NFRecurveBow.cs

datablock AudioProfile(DCritSound)
{
   filename    = "./Dcrit.wav";
   description = AudioClosest3d;
   preload = true;
};

//audio
datablock AudioProfile(BlankSound)
{
   filename    = "./Blank.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(NFRecurveBowExplosionSound)
{
   filename    = "./sounds/arrowHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(NFRecurveBowFireSound)
{
   filename    = "./sounds/Fire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(NFRecurveBowChargeSound)
{
   filename    = "./sounds/charge.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(NFRecurveBowFireFireSound)
{
   filename    = "./sounds/FireFire.wav";
   description = AudioClose3d;
	preload = true;
};
datablock ParticleData(FireTrailParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 3.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 100;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";

	sizes[0]	= 0.0;
	sizes[1]	= 1.0;
	sizes[2]	= 0.6;

	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(FireTrailEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 1;
   ejectionOffset   = 0.00;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;

   //lifetimeMS = 5000;
   particles = FireTrailParticle;   


};

datablock ParticleData(RBowFireParticle)
{
	textureName          = "base/data/particles/cloud";
	dragCoefficient      = 0.10;
	gravityCoefficient   = -15.10;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 5.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	spinSpeed     = 0;
	spinRandomMin = -90.0;
	spinRandomMax =  90.0;
	useInvAlpha   = false;

	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";

	sizes[0]	= 0.0;
	sizes[1]	= 0.5;
	sizes[2]	= 0.2;

	times[0]	= 0.0;
	times[1]	= 0.2;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(RBowFireEmitter)
{
   ejectionPeriodMS = 14;
   periodVarianceMS = 4;
   ejectionVelocity = 1;
   ejectionOffset   = 0.00;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 5;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   //lifetimeMS = 5000;
   particles = RBowFireParticle;   


};
datablock ParticleData(RecurveArrowTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.5 0.5 0.5 0.2";
	colors[1]	= "0.5 0.5 0.5 0.0";
	sizes[0]	= 0.1;
	sizes[1]	= 0.1;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(RecurveArrowTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = RecurveArrowTrailParticle;

   useEmitterColors = true;


};

datablock ExplosionData(RecurvearrowStickExplosion)
{
   //explosionShape = "";
	soundProfile = NFRecurveBowExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = "";
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};
datablock ParticleData(NFRecurveBowFireExplosionParticle)
{
   textureName          = "./particles/smoke";
   dragCoefficient      = 2;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 150;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.56 0.36 0.26 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 1.0;
};

datablock ParticleEmitterData(NFRecurveBowFireExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "NFRecurveBowFireExplosionParticle";
};

datablock ParticleData(NFRecurveBowFireExplosionSmoke)
{
   textureName          = "./particles/smoke";
   dragCoeffiecient     = 100.0;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.25;
   constantAcceleration = -0.80;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 300;
   useInvAlpha =  true;
   spinRandomMin = -80.0;
   spinRandomMax =  80.0;

   colors[0]     = "0.56 0.36 0.26 1.0";
   colors[1]     = "0.2 0.2 0.2 1.0";
   colors[2]     = "0.0 0.0 0.0 0.0";

   sizes[0]      = 1.0;
   sizes[1]      = 1.5;
   sizes[2]      = 2.0;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(NFRecurveBowFireExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 4;
   velocityVariance = 0.5;
   thetaMin         = 0.0;
   thetaMax         = 180.0;
   lifetimeMS       = 250;
   particles = "NFRecurveBowFireExplosionSmoke";
};

datablock ParticleData(NFRecurveBowFireExplosionSparks)
{
   textureName          = "./particles/spark";
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 350;

   colors[0]     = "0.60 0.40 0.30 1.0";
   colors[1]     = "0.60 0.40 0.30 1.0";
   colors[2]     = "1.0 0.40 0.30 0.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.25;
   sizes[2]      = 0.25;

   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(NFRecurveBowFireExplosionSparkEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 13;
   velocityVariance = 6.75;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 100;
   particles = "NFRecurveBowFireExplosionSparks";
};
datablock ExplosionData(RecurvearrowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(NFRecurveBowFireSubExplosion1)
{
   offset = 1.0;
   emitter[0] = NFRecurveBowFireExplosionSmokeEmitter;
   emitter[1] = NFRecurveBowFireExplosionSparkEmitter;
};

datablock ExplosionData(NFRecurveBowFireSubExplosion2)
{
   offset = 1.0;
   emitter[0] = NFRecurveBowFireExplosionSmokeEmitter;
   emitter[1] = NFRecurveBowFireExplosionSparkEmitter;
};

datablock ExplosionData(NFRecurveBowFireExplosion)
{
   soundProfile   = NFRecurveBowFireFireSound;
   lifeTimeMS = 1200;

   // Volume particles
   particleEmitter = NFRecurveBowFireExplosionEmitter;
   particleDensity = 80;
   particleRadius = 1;

   // Point emission
   emitter[0] = NFRecurveBowFireExplosionSmokeEmitter;
   emitter[1] = NFRecurveBowFireExplosionSparkEmitter;

   // Sub explosion objects
   subExplosion[0] = NFRecurveBowFireSubExplosion1;
   subExplosion[1] = NFRecurveBowFireSubExplosion2;
   
   // Camera Shaking
   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0";
   lightEndColor = "0 0 0";
      radiusDamage        = 50;
   damageRadius        = 10;
};

datablock ProjectileData(NFRecurveBowProjectile)
{
   projectileShapeName = "add-ons/weapon_bow/arrow.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::ArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::ArrowDirect;



   particleEmitter       = RecurveArrowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 20000;
   lifetime            = 20000;
   fadeDelay           = 20000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.65;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 75;
   velInheritFactor    = 1;
};
datablock ProjectileData(NFRecurveBowunchargedProjectile)
{
   projectileShapeName = "add-ons/weapon_bow/arrow.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::ArrowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::ArrowDirect;



   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.8;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   muzzleVelocity      = 30;
   velInheritFactor    = 1;
};

//////////
// item //
//////////
datablock ItemData(NFRecurveBowItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/NFRBowItem.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "NF Recurved Bow";
	iconName = "./icons/RBow";
	doColorShift = true;
	colorShiftColor = "0.882353 0.443137 0 1";

	 // Dynamic properties defined by the scripts
	image = NFRecurveBowImage;
	canDrop = true;
};

//function NFRecurveBow::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(NFRecurveBowImage)
{
   // Basic Item properties
   shapeFile = "./shapes/NFRBow3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.3 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
//exec("add-ons/weapon_NFRecurveBow/server.cs");
   // Projectile && Ammo.
   item = NFRecurveBowItem;
   ammo = " ";
   projectile = NFRecurveBowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise youwr arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.882353 0.443137 0 1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";

	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	stateScript[1]		= "onready";
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateSound[2]				= NFRecurveBowChargeSound;
	stateTimeoutValue[2]            = 1;
	stateSequence[2]		= "Charge";
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";

	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTimeoutValue[3]		= 0.4;
	stateFire[3]			= true;
	stateSequence[3]		= "Fire";
	stateScript[3]			= "onFiretwo";
	stateWaitForTimeout[3]		= true;
	stateSound[3]				= NFRecurveBowFireSound;
	stateAllowImageChange[3]	= false;
	stateTransitionOnTimeout[3]	= "Reload";

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTimeoutValue[5]		= 0.2;
	stateFire[5]			= true;
	stateSequence[5]		= "Fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= NFRecurveBowFireSound;
	stateTransitionOnTimeout[5]	= "Reload";
	//--------------------------------------------------------------------------------------Skip over
		stateName[6]			= "Reload";
	stateTimeoutValue[6]		= 0.6;
	stateTransitionOnTimeout[6]	= "Ready";
	stateSequence[6]		= "reload";
		stateAllowImageChange[6]	= false;
};
function NFRecurveBowImage::onFiretwo(%this,%obj,%slot)
{

	

	%projectile = NFRecurveBowunchargedprojectile;
	%spread = 0.1;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function NFRecurveBowImage::onFireFire(%this,%obj,%slot)
{

	

	%projectile = NFRecurveBowFireprojectile;
	%spread = 0.00001;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function NFRecurveBowImage::onMount(%this, %obj, %slot)
{
	  	 %obj.hideNode(lhand);
	  	 %obj.hideNode(lhook);
	     %obj.hideNode(rhand);
	  	 %obj.hideNode(rhook);
}

function NFRecurveBowImage::onUnMount(%this, %obj, %slot)
{
	  	%obj.unhideNode(lhand);
		%obj.unhideNode(rhand);
}

function NFRecurveBowImage::onReady(%this, %obj, %slot)
{
	  	 %obj.hideNode(lhand);
	  	 %obj.hideNode(lhook);
	     %obj.hideNode(rhand);
	  	 %obj.hideNode(rhook);
}








